#include "player.h"
#include "Get_Key.h"

//#include "ConLib.h"
//#include "Get_Key.h"

Player::Player(string nme, int hlt, int mp, int str, int agi,
						int exp, int lvl, int mny, int points)
{

	name	= nme;
	Hp		= hlt;
	Mp		= mp;
	Str		= str;
	Agi		= agi;
	Exp		= exp;
	Lvl		= lvl;
	Mny		= mny;
	HpDmg	= hlt;
	tPoints = points;
}


//ostream& operator<<(ostream &o, const Player& p)
//{
//	ConLib c;

//	o<<p.name << "|" << p.Lvl << "|" << p.Exp << '\n' <<"HP: ";

//	o << p.HpDmg << "/" << p.Hp <<'\n';

//	return o;
//}

void Player::setName(string nme)
{
	name = nme;
}

void Player::printPlayer()
{

	cout << name << '|' << Lvl << '|' << Exp << '\n';
	cout << "HP:" << HpDmg << '/' << Hp << '\n';
	cout << "Money: " << Mny << '\n';
	cout << "Mp: "<< Mp << '\n';
	cout << "Str: " << Str << '\n';
	cout << "Agi: " << Agi << '\n';
}

string Player::getName()
{
	return name;
}

int Player::getHp()
{
	return HpDmg;
}

void Player::decreaseHp(int dmg)
{
	HpDmg -= dmg;
	if(HpDmg <0)
		HpDmg = 0;
}


int Player::doDmg()
{
	int dmg = rand() % ((Hp+Str)/4);

	return dmg;
}

bool Player::isAlive()
{
	if(HpDmg == 0)
		return false;
	else 
	  return true;
}

void Player::setMoney(int money)
{
	Mny += money;
}

int Player::getMoney()
{
	return Mny;
}
void Player::increaseExp(int more)
{
	Exp += more;
}

int Player::getExp()
{
	return Exp;
}

void Player::levelUp(bool& nLevel)
{
	int exp = Exp;
	if(exp >= 100)
	{
		Exp -=100;
		Lvl += Lvl;
		tPoints +=5;
		
		nLevel = true;

	}
	else
    {
        cout << 100 - Exp << " exp points to next level." << endl;
		nLevel = false;
	}
}
void Player::talentsUpdate(Player& player, bool& nLevel)
{
	if(player.isAlive() && nLevel)
	{
		
		int addChoice;
		cout << "You have " << tPoints << " talent points to use." << endl;

		while(tPoints != 0)
		{
			cout << "Your current stats are: \n";
			player.printPlayer();
			cout << "\n\n";
			cout << "Which would you like to update" << endl;
			cout << "1.Hp\n";
			cout << "2.Mp\n";
			cout << "3.Str\n";
			cout << "4.Agi\n";
			int choice = getch();
			int c_Choice;

			bool nChoice = false;
			switch(choice)
			{
			case '1':	cout << "How much would you like to add to Hp?" << endl;
				while(!nChoice)
				{
					c_Choice = getch();
					
					switch(c_Choice)
					{
					case '1': addChoice = 1;
						nChoice = true;
						break;
					case '2': addChoice = 2;
						nChoice = true;
						break;
					case '3': addChoice = 3;
						nChoice = true;
						break;
					case '4': addChoice = 4;
						nChoice = true;
						break;
					case '5': addChoice = 5;
						nChoice = true;
						break;
					default: cout << "You do not have enough talent points\n";
						break;
					}
				}

					if(addChoice > tPoints)
						cout << "You do not have enough talent points.\n";
						tPoints -= addChoice;
						Hp += addChoice * 10;
					
					break;
			/*
			case '2': cout << "How much would you like to add to Mp?" << endl;
					
					c_Choice = get_Key();

				while(!nChoice)
				{
					
					switch(c_Choice)
					{
					case Key_1: addChoice = 1;
						nChoice = true;
						break;
					case Key_2: addChoice = 2;
						nChoice = true;
						break;
					case Key_3: addChoice = 3;
						nChoice = true;
						break;
					case Key_4: addChoice = 4;
						nChoice = true;
						break;
					case Key_5: addChoice = 5;
						nChoice = true;
						break;
					default: cout << "You do not have enough talent points\n";
						break;
					}
					
						tPoints -= addChoice;
						Mp += addChoice * 10;
				}
					
					break;
			case Key_3: cout << "How much would you like to add to Str?" << endl;
				c_Choice = get_Key();

				while(!nChoice)
				{
					
					switch(c_Choice)
					{
					case Key_1: addChoice = 1;
						nChoice = true;
						break;
					case Key_2: addChoice = 2;
						nChoice = true;
						break;
					case Key_3: addChoice = 3;
						nChoice = true;
						break;
					case Key_4: addChoice = 4;
						nChoice = true;
						break;
					case Key_5: addChoice = 5;
						nChoice = true;
						break;
					default: cout << "You do not have enough talent points\n";
						break;
					}
				}
                        tPoints -= addChoice;
						Str += addChoice;
					
					break;
			case Key_4: cout << "How much would you like to add to Agi?" << endl;
					c_Choice = get_Key();
				while(!nChoice)
				{
					
					switch(c_Choice)
					{
					case Key_1: addChoice = 1;
						nChoice = true;
						break;
					case Key_2: addChoice = 2;
						nChoice = true;
						break;
					case Key_3: addChoice = 3;
						nChoice = true;
						break;
					case Key_4: addChoice = 4;
						nChoice = true;
						break;
					case Key_5: addChoice = 5;
						nChoice = true;
						break;
			*/
					default: cout << "You do not have enough talent points\n";
						break;
					}
					
						tPoints -= addChoice;
						Agi += addChoice;
						break;
			}

					if(tPoints == 0)
					{
						cout << "\nYou have no talent points left.\n";
						cout << "Your current stats are:\n\n";
						player.printPlayer();
					}

	}
		
	
	
	if(tPoints == 0)
	{
		cout << "You have " << tPoints << " talent points" <<  endl;
		cout << "Your current stats are: \n";
		player.printPlayer();
		cout << "\n\n";
	}
	
}


